#include "demo.h"
#include "gl.h"

#include "GL/gl.h"

#include "window.h"
#include "light.h"

#include "scene.h"
#include "endscene.h"
#include "eh.h"

#include "hamster.h" // egentlig wombattex
#include "skipper.h" 
#include "ib.h" 
#include "bottle.h"
#include "wombatulf.h"
#include "particle.h"

#include "roachtunnell.h"

#include <unistd.h>
#include <cstdlib>

#include <SDL/SDL.h>

#include <sys/ioctl.h>
#include <linux/soundcard.h> // SNDblablaIOCTL

#include <pthread.h>

int demo::time;

scene *s[SCENES];

light *demo::l;

Blur *demo::blurscene;

bool demo::blur;

bool demo::blurring;

texture *demo::hamstertex;

struct OggVorbis_File demo::oggfil;

FILE *demo::oggfilf;

FILE *demo::lydfilf;

bool demo::done;

volatile unsigned long int demo::written;

void tegn_nam();
void tegn_firkant(int tex);
void tegn_partikkel(double, double, double);

texture *wombattex;
texture *skippertex;
texture *ib;
texture *bottle;
texture *wombatulf;
texture *particle;

void demo::init() {
	blur=true;

	hamstertex = new texture(HAMSTER_DATA, HAMSTER_LEN, true, GL_RGB);
	wombattex = new texture(HAMSTER_DATA, HAMSTER_LEN, true, GL_BYTE);
	skippertex = new texture(SKIPPER_DATA, SKIPPER_LEN, true, GL_RGB);
	ib = new texture(IB_DATA, IB_LEN, true, GL_RGB);
	bottle = new texture(BOTTLE_DATA, BOTTLE_LEN, true, GL_RGB);
	wombatulf = new texture(WB_DATA, WB_LEN, true, GL_RGB);
	particle = new texture(PART_DATA, PART_LEN, true, GL_BYTE);

	oggfilf = fopen("data/lyd.ogg", "r");

	if(oggfilf == NULL) {
		printf("fuck, fikk ikke pnet ikke data/lyd.ogg.\n");
		exit(1);
	}
	
	if(0 != ov_open(oggfilf, &oggfil, NULL, 0)) {
		printf("fuck, problemer med vorbisfile \\: \n");
		exit(1);
	}

	if(!lyd_init()) {
		printf("bleh. lyden fucka. \\: \n");
		exit(1);
	}

	pthread_t thread;
	pthread_create(&thread, NULL, spill_musikk, NULL);
	
//	s[0] = new testscene;
	s[0] = new roachtunnell;

	blurscene = new Blur;
	l = new light(0.0, 0.0, 2.0);
//	float fv[4] = {0.0, 0.0, 0.0, 0.0};

	usleep(1000);
	demo::time = 0;
}

void demo::doframe() {

	time = get_time();

	bool strobe = false;

	if( ( (time > 41000) && (time < 73000) ) || ( (time > 105000) && (time < 137000) ) ) {
		strobe = true;
	}

	if((((time-75) % 1000) < 150 && strobe)) {
		w->setclearcolor(1.0, 1.0, 1.0);
	} else {
		w->setclearcolor(0.0, 0.0, 0.0);
	}

	gl::predraw();
	
	l->show();
	
	if(time < 7000) {
		glScalef(3.0, 2.0, 1.0);
		glEnable(GL_BLEND);
		glDisable(GL_LIGHTING);
		glColor4f(1,1,1,(float)time/7000);
		glBlendFunc(GL_ONE, GL_ONE);
		tegn_firkant(ib->get_num());
		glDisable(GL_BLEND);
		glEnable(GL_LIGHTING);
	} else if (time < 40000) {
		glPushMatrix();
		glTranslatef(-2.0, -1.0, 0.0);
		glScalef(0.7, 1.0, 1.0);	
		tegn_firkant(skippertex->get_num());
		glPopMatrix();
	
		glTranslatef(0.0, 1.0, -5.0);
		glPushMatrix();
		glRotatef(45, 0.0, 0.0, 1.0);
		for(int i = 0; i < (time - 7000)/500; i++) {
			glRotatef(75, 1.0, 0.0, 0.0);
			glPushMatrix();
			glTranslatef( -pow((float)(time-7000)/1000 - i - 0.5, 2)/1.5, (float)(time-7000)/1000 - i, 0.0);
			tegn_nam();
			glPopMatrix();
		}
		glPopMatrix();
		
	} else if (time < 72000) {
		glEnable(GL_BLEND);
		glDisable(GL_LIGHTING);
		glColor4f(1,1,1,(float)time/7000);
		glBlendFunc(GL_ONE, GL_ONE);
		if((time % 1000) < 500) {
			glScalef(1.0, 2.0, 1.0);
			tegn_firkant(bottle->get_num());
		} else {
			tegn_firkant(wombatulf->get_num());
		}
		glDisable(GL_BLEND);
		glEnable(GL_LIGHTING);
		
	} else if (time < 104000) {
		glRotatef((float)time/((104000-time)/10), 0.0, 0.0, 1.0);
		glPushMatrix();
		glScalef(3.0, 2.0, 1.0);
		glEnable(GL_BLEND);
		glDisable(GL_LIGHTING);
		glColor4f(1,1,1,(float)time/7000);
		glBlendFunc(GL_ONE, GL_ONE);
		tegn_firkant(ib->get_num());
		glPopMatrix();
		glPushMatrix();
		glRotatef(45, 0.0, 0.0, 1.0);
		for(int i = 0; i < (time - 7000)/500; i++) {
			glRotatef(75, 1.0, 0.0, 0.0);
			glPushMatrix();
			glTranslatef( -pow((float)(time-7000)/1000 - i - 0.5, 2)/1.5, (float)(time-7000)/1000 - i, 0.0);
			tegn_nam();
			glPopMatrix();
		}
		glPopMatrix();
	} else if (time < 136000) {
		glPushMatrix();
		glTranslatef(0.0, -1.0, -1.0);
		glPushMatrix();
		glScalef(1.0, 2.0, 1.0);
		tegn_firkant(bottle->get_num());
		glPopMatrix();
		glPushMatrix();
		glTranslatef(0.0, 0.0, 1.0);
		for(int i = 0; i < (time - 104000)/300; i++) {
			glPushMatrix();
			glTranslatef( 0.0 , (float)(time-104000)/1000 - i, 0.0);
			glScalef(0.1, 0.1, 1.0);
			tegn_firkant(particle->get_num());
			glPopMatrix();
		}
		glPopMatrix();
	} else if (time < 168000) {
		glPushMatrix();
		glRotatef((float)time/20, 0.0, 0.0, 1.0);
		glScalef(3.0+sin((float)time/1000), 2.0+cos((float)time/1200), 1.0);
		glEnable(GL_BLEND);
		glDisable(GL_LIGHTING);
		glColor4f(1,1,1,(float)time/7000);
		glBlendFunc(GL_ONE, GL_ONE);
		tegn_firkant(ib->get_num());
		glPopMatrix();
		glPushMatrix();
		glRotatef((float)time/13, 0.0, 0.0, -1.0);
		glScalef(3.0+sin((float)time/1000), 2.0+cos((float)time/100), 1.0);
		glEnable(GL_BLEND);
		glDisable(GL_LIGHTING);
		glColor4f(1,1,1,(float)time/7000);
		glBlendFunc(GL_ONE, GL_ONE);
		tegn_firkant(ib->get_num());
		glPopMatrix();
	} else {
		done = true;
	}
	
	if(blur) {
		blurring = true;
		blurscene->init_blur();

		for(int i = 0; i < SCENES; i++) {
			glPushMatrix();
			s[0]->draw();
			glPopMatrix();
		}
		
		blurscene->end_blur();
	}
	blurring = false;

/*	for(int i = 0; i < SCENES; i++) {
		glPushMatrix();
		s[i]->draw();
		glPopMatrix();
	}*/
//	s[0]->draw();

	if(blur) blurscene->draw_blur();
	
//	s[0]->draw();
	
	gl::draw();
	gl::postdraw();
	
}


void demo::quit() {
	delete w;
	for(int i = 0; i < SCENES; i++) {
		delete s[i];
	}
//	delete s[0];
	exit(0);
}

void demo::run() {
	done = false;
	Uint8* keys;

	while(!done) {
		
		doframe();

		SDL_Event event;
		while(SDL_PollEvent(&event)) {
			switch(event.type) {
				case SDL_QUIT:
					done = true;
					break;
				default:
					break;
			}
		}

		keys = SDL_GetKeyState(NULL);

		if(keys[SDLK_ESCAPE]) done = true;
		if(keys[SDLK_t]) {
			dprint("tid:" << demo::time << std::endl);
		}

	}
	printf("uNF!");
	demo::quit();
}

int demo::get_time() {
	unsigned long delay = 0;
	ioctl(fileno(demo::lydfilf), SNDCTL_DSP_GETODELAY, &delay);
	return (int)( ( (float)(demo::written - delay) / (44100 * 4))*((float)97/60) * 1000 );
}

bool demo::lyd_init() {

	lydfilf = fopen("/dev/dsp", "w");

	if(lydfilf == NULL) {
		return false;
	}

    int temp = 16;
    ioctl(fileno(demo::lydfilf), SNDCTL_DSP_SAMPLESIZE, &temp);
    if (temp != 16)
    {
      return false;
    }
    temp = 1;
    ioctl(fileno(demo::lydfilf), SNDCTL_DSP_STEREO, &temp);
    if (temp != 1)
    {
      return false;
    }
    temp = 44100;
    ioctl(fileno(demo::lydfilf), SNDCTL_DSP_SPEED, &temp);
    if (temp != 44100)
    {
      return false;
    }

	return true;
}


void *demo::spill_musikk(void* ost) {

  char pcmout[4096];
  int current_section;
  bool eof = false;
  demo::written = 0;
  while(!eof){
    long ret=ov_read(&demo::oggfil,pcmout,sizeof(pcmout), 0, 2, 1, &current_section);
    if (ret == 0) {
      eof=true;
    } else if (ret < 0) {
    } else {
      fwrite(pcmout,1,ret,demo::lydfilf);
	  demo::written += ret;
    }
  }
}

void tegn_firkant(int tex) {
	glPushMatrix();
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_LIGHTING);
	glBlendFunc(GL_ONE,GL_ONE);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glBindTexture(GL_TEXTURE_2D, tex);
	glTranslatef(0.0, 0.0, -5.0);
	glColor3f(1.0, 1.0, 1.0);
	glNormal3f(0.0, 0.0, 1.0);
	glBegin(GL_POLYGON); {
		glTexCoord2i(0, 1);
		glVertex3f(-1.0, -1.0, 0.0);
		glTexCoord2i(1, 1);
		glVertex3f(1.0, -1.0, 0.0);
		glTexCoord2i(1, 0);
		glVertex3f(1.0, 1.0, 0.0);
		glTexCoord2i(0, 0);
		glVertex3f(-1.0, 1.0, 0.0);
	} glEnd();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glEnable(GL_LIGHTING);
	glPopMatrix();


}

void tegn_nam() {
	glPushMatrix();
	glColor3f(0.1, 0.1, 0.1);
	glEnable(GL_COLOR_MATERIAL);
	glScalef(0.4, 0.4, 0.4);
	for(int z = -1; z <= 2; z +=2) {
		glNormal3f(sin(0.5), 0.0, z*cos(0.5));
		glBegin(GL_TRIANGLE_FAN); {
			glVertex3f(0.0, 0.0, 0.0);
			for(float f = -(M_PI/2.0); f < (M_PI/2.0); f += 0.3) {
				glVertex3f(f, cos(f), z*fabs(cos(f))/4);
			}
		} glEnd();
	}
	glBegin(GL_QUAD_STRIP); {
		for(float f = -(M_PI/2.0); f < (M_PI/2.0); f += 0.3) {
			glNormal3f(sin(f), cos(f), 0.0);
			glVertex3f(f, cos(f), fabs(cos(f))/4);
			glVertex3f(f, cos(f), -fabs(cos(f))/4);
		} 
	} glEnd();
	glPopMatrix();
}
