#include "rass.h"

#include <math.h>
#include <GL/gl.h>
#include <stdlib.h>

// the almighty rasshl
#define FUNK -(pow(x/2, 2)/2+pow(y,2)/2+(abs(x) > ((M_PI-1.05)/2)-stopx/steps ? 0 : cos(x)*2) + cos(x)*2-stopy/steps)

const int steps = 50;

const GLfloat starty = -5.0;
const GLfloat startx = -5.0;
const GLfloat stopy = 5.0;
const GLfloat stopx = 5.0;

float rassdata[steps][steps];

void init_rass() {
	float x, y;
	for(int i = 0; i < steps; i++) {
		for(int j = 0; j < steps; j++) {
			x = (float) ((float)i-(steps/2))/4.7;
			y = (float) ((float)j-(steps/2))/4.7;
			rassdata[i][j] = FUNK;
		}
	}
}

void draw_rass() {
	
	float dx = (stopx - startx)/steps;
	float dy = (stopy - starty)/steps;
	
	float xting = stopx - startx;
	float yting = stopy - starty;
	
	glEnable(GL_TEXTURE_2D);
//	glBindTexture(GL_TEXTURE_2D,0);
	glPushMatrix();
	glDisable(GL_LIGHTING);
	
	float z, z_next_x, z_next_y, z_next_x_y;
	
	for(int i = 0; i < steps-1; i++) {
		for(int j = 0; j < steps-1; j++) {
			float posx = (float) ((float)i-(steps/2)) / 5;
			float posy = (float) ((float)j-(steps/2)) / 5;
			glTranslatef(posx, posy, 0);
			glBegin(GL_POLYGON);
			z = rassdata[i][j];
			z_next_x = rassdata[i+1][j];
			z_next_y = rassdata[i][j+1];
			z_next_x_y = rassdata[i+1][j+1];
			
			glTexCoord2f((posx+xting)/xting, (posy+yting)/yting);
			glVertex3f(0,0,z);

			glTexCoord2f((posx+dx+xting)/xting, (posy+yting)/yting);
			glVertex3f(dx, 0, z_next_x);

			glTexCoord2f((posx+dx+xting)/xting, (posy+dy+yting)/yting);
			glVertex3f(dx, dy, z_next_x_y);

			glTexCoord2f((posx+xting)/xting, (posy+dy+yting)/yting);
			glVertex3f(0, dy, z_next_y);
			glEnd();
			glTranslatef(-posx,-posy,0);
			
		}
	}
	glEnable(GL_LIGHTING);
	glEnd();
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
}
